//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpKeyGenDoThrds.h"
#include "PGPbuffers.h"
#include "PgpFiles.h"
#include "Global.h"
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall PgpKeyGenDoThrd::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
int __fastcall GenerateRSAkey(HINSTANCE hMixLib, int Bits, char *Userid,
   char *Passwd, int Remail)
{
   int result=0;
   TPgpKeyGenDoThrd *genthrd = new TPgpKeyGenDoThrd(hMixLib,Bits,Userid,Passwd,Remail,
      &result);
   delete genthrd;
   return result;
}
//---------------------------------------------------------------------------
/*__fastcall TPgpKeyGenDoThrd::TPgpKeyGenDoThrd(bool CreateSuspended)
  : TThread(CreateSuspended)
{
}*/
//---------------------------------------------------------------------------
__fastcall TPgpKeyGenDoThrd::TPgpKeyGenDoThrd(HINSTANCE hMixLib, int Bits, char *Userid,
   char *Passwd, int Remail, int *Result) : TThread(true)
{
   hmixlib = hMixLib;
   bitcnt = Bits;
   userid = buf_new(); buf_sets(userid,Userid); //sm(s("#")+(char*)userid->data+s("#"));
   passwd = buf_new(); buf_sets(passwd,Passwd); //sm(s("#")+(char*)passwd->data+s("#"));
   remail = Remail;
   ReturnValue = 0;
   result = Result; *result = 0;
// FreeOnTerminate = true;
   Resume();
//   *result = WaitFor();
//sm("okiedokis");
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDoThrd::Execute()
{
   //---- Place thread code here ----
   lstrcpy(pubring,PgpPublicRing().c_str());//"c:\\mywork~1\\cbuilder\\qs1\\pubring.pkr");//PgpPublicRing().c_str());
   lstrcpy(secring,PgpSecretRing().c_str());//"c:\\mywork~1\\cbuilder\\qs1\\secring.skr");//PgpSecretRing().c_str());
   *result = pgp_keygen(PGP_ES_RSA,0,userid,passwd,pubring,secring,1);
}
//---------------------------------------------------------------------------
void __fastcall TPgpKeyGenDoThrd::Show()
{
   ShowMessage(*result);
}
//---------------------------------------------------------------------------
int __fastcall TPgpKeyGenDoThrd::pgp_keygen(int algo, int bits, BUFFER *userid,
   BUFFER *pass, char *pubring, char *secring, int remail)
{
   PGPKEYGEN pgpkeygen;
   if ((pgpkeygen=(PGPKEYGEN)GetProcAddress(hMixLib,"pgp_keygen"))!=NULL)
      *result = (pgpkeygen)(algo,bits,userid,pass,pubring,secring,remail);
   return *result;
}
//---------------------------------------------------------------------------
